include numerals.Abs.gf ;
flags coding=latinasupplement ;

-- D^ is from implosive d IPA symbol
-- N Num 

param Size = sg | two | three | other ;

oper LinDigit = {s : Str ; size : Size} ;

lincat Numeral = {s : Str} ;
lincat Digit = LinDigit ;
lincat Sub10 = LinDigit ;
lincat Sub100 = LinDigit ;
lincat Sub1000 = LinDigit ;
lincat Sub1000000 = {s : Str} ;

oper mkNum : Str -> LinDigit = \kunun ->
  {s = kunun ; size = other} ;

lin num x0 =
  {s = "/L" ++ x0.s ++ "L/"} ; -- for D^ 

lin n2 = {s = variants {"pllw" ; "fllw"} ; size = two }; 
lin n3 = {s = "knn" ; size = three }  ;
lin n4 = mkNum (variants {"pD^w" ; "fD^w"}) ;
lin n5 = mkNum (variants {"paD^" ; "faD^"}) ;
lin n6 = mkNum (variants {"pynd" ; "fynd"}) ;
lin n7 = mkNum (variants {"ppllw" ; "fpllw"}) ;
lin n8 = mkNum (variants {"pwrD^w" ; "fwrD^w"}) ;
lin n9 = mkNum "lmbD^" ;

oper thirty : Str = variants {("ku" ++ "knn") ; "tlatn"} ;
oper two100 : Str = variants {"dlmg" ++ "pllw" ; "metn"} ;
oper thousand : Str = variants {("dlmg" ++ "km") ; "dbk" ; "dbk"} ;

lin pot01  =
  {s = "mnd" ; size = sg};
lin pot0 d = d ;
lin pot110 = mkNum "km" ; 
lin pot111 = mkNum ("km" ++ "kn" ++ "mnd") ;
lin pot1to19 d = mkNum ((variants {"km" ++ "kn" ; "tr"}) ++ d.s ) ;
lin pot0as1 n = n ;
lin pot1 d = mkNum (table {three => thirty ; _ => "ku" ++ d.s} ! d.size) ; 
lin pot1plus d e = mkNum ((table {three => thirty ; _ => "ku" ++ d.s} ! d.size) ++ "kn" ++ e.s) ;
lin pot1as2 n = n ;
lin pot2 d = mkNum (table {sg => (variants {"dlmg" ; "dlmk"}) ; two => two100 ; _ => "dlmg" ++ d.s } ! d.size) ; 
lin pot2plus d e = mkNum ((table {two => two100 ; sg => (variants {"dlmg" ; "dlmk"}) ; _ => "dlmg" ++ d.s } ! d.size) ++ "kn" ++ e.s) ;
lin pot2as3 n = {s = n.s} ;
lin pot3 n = {s = table {sg => thousand ; _ => "dbk" ++ n.s} ! n.size } ;
lin pot3plus n m = {s = table {sg => thousand ; _ => "dbk" ++ n.s} ! n.size ++ m.s} ;