--# -path=.:../abstract:../../prelude

concrete MoreTestSwe of MoreTest = StructuralSwe ** open Prelude, SyntaxSwe in {

flags startcat=Phr ; lexer=text ; unlexer=text ;

-- a random sample from the lexicon

lin
--aFin, aFager, aGrund, aVid, aVaken, aKorkad,  aAbstrakt

Big = stor_25 ;
Small = liten_1146 ;
Old = gammal_16 ;
Young = ung_29 ;

American = extAdjective (aFin "amerikansk") ;
Finnish = extAdjective (aFin "finsk") ;
Married = extAdjective (aAbstrakt "gift") ** {s2 = "med"} ;

Happy = aFin "lycklig" ;
Free = aFin "ledig" ;
Slow = aFin "lngsam" ;
New = aVid "ny" ;
Own = aVaken "eg" ;
Fresh = aFin "frisk" ; 
Interested = aGrund "intressera" ;


--sApa, sBil sPojke, sNyckel sKam sSak , sVarelse , 
--sNiv, sParti,sMuseum sRike sLik sRum sHus sPapper 
--sNummer sKikare, sProgram
Finale = extCommNoun NoMasc (sSak "final") ; 
Idea = extCommNoun NoMasc (sBil "id") ; 
Orientation = extCommNoun NoMasc (sBil "orientering") ; 
Air = extCommNoun NoMasc (sBil "luft") ;
Golf = extCommNoun NoMasc (sBil "golf") ;
Man = extCommNoun Masc man_1144 ;
Bar = extCommNoun NoMasc (sSak "bar") ;
DrinkS = extCommNoun NoMasc (sSak "drink") ;
Book = extCommNoun NoMasc (sSak "bok") ; -- omljud?
Bottle = extCommNoun NoMasc (sApa "flask") ;
Letter = extCommNoun NoMasc (sHus "brev") ;
Fiance = extCommNoun NoMasc (sNiv "fstm") ;
Woman = extCommNoun NoMasc (sApa "kvinn") ;
Car = extCommNoun NoMasc (sBil "bil") ;
House = extCommNoun NoMasc (sHus "hus") ;
Glass = extCommNoun NoMasc (sHus "glas") ;
Light = extCommNoun NoMasc (sHus "ljus") ;
Wine = extCommNoun NoMasc (sParti "vin") ;
Success = extCommNoun NoMasc (sBil "framgng") ;
Seriousness = extCommNoun NoMasc (sHus "allvar") ;
Chair = extCommNoun NoMasc (sBil "stol") ;
Fever = extCommNoun NoMasc (sBil "feber") ;
HomeBake = extCommNoun NoMasc (sBil "hembakt") ; --mste ndra sen
Competition = extCommNoun NoMasc (sBil "tvling") ;
CinemaVisit = extCommNoun NoMasc (sHus "biobesk") ;

-- Nomen med en-stllig funktion
Mother = mkFun (extCommNoun NoMasc mor_1) "till" ;
Uncle = mkFun (extCommNoun Masc farbror_8) "till" ;

-- Nomen med tv-stllig funktion
Connection = mkFun (extCommNoun NoMasc (sVarelse "frbindelse")) "frn" ** 
         {s3 = "till"} ;


--vTala, vLeka vTyda vVnda
--vByta vGmma vHyra vTla
--vFinna

-- Intransitiva verb
Walk = extVerb Act g_1174 ;
Run = extVerb Act (vFinna "spring" "sprang" "sprung") ;
Dance = extVerb Act (vTala "dans") ;
Rain = extVerb Act (vTala "regn") ;
Sleep = extVerb Act (vFinna "sov" "sov" "sov") ;
Sail = extVerb Act (vTala "segl") ;

--Monotransitiva verb
Surprise = extTransVerb (vTala "verrask") [] ;
Drink = extTransVerb (vFinna "drick" "drack" "druck") [] ;
Love = extTransVerb (vTala "lsk") [] ;
Send = extTransVerb (vTala "skick") [] ;
Wait = extTransVerb (vTala "vnt") "p" ;
Build = extTransVerb (vLeka "bygg") [] ;
Buy = extTransVerb (vLeka "kp") [] ;
Rent = extTransVerb (vHyra "hyr") [] ;
MakeDo = extTransVerb (vHyra "gr") [] ; --Hack!
Hug = extTransVerb (vTala "kram") [] ;
Have = extTransVerb hava_1198 [] ;
Like = extTransVerb (vTala "gill") [] ;
Take = extTransVerb (vFinna "ta" "tog" "tag") [] ; --
Start = extTransVerb (vTala "start") [] ;
Play = extTransVerb (vTala "spel") [] ;
Win = extTransVerb (vFinna "vinn" "vann" "vunn") [] ;

--Bitransitiva verb
Give2 = extTransVerb (vFinna "giv" "gav" "giv") [] ** {s3 = ""} ; -- ge
Envy = extTransVerb (vTala "missunn") [] ** {s3 = ""} ; 

--(Bi)transverb med obligatorisk pp
Give = extTransVerb (vFinna "giv" "gav" "giv") [] ** {s3 = "till"} ; -- ge
Accustomize = extTransVerb (vFinna "vnj" "vande" "van")  [] ** {s3 = "vid"} ; -- 
Steal = extTransVerb (vHyra "stjl") [] ; -- oh o hur ska detta bjas?

Devote = extTransVerb (vTala "gn")  [] ** {s3 = "t"} ; -- 
Remind = extTransVerb (vTla "pminn")  [] ** {s3 = "om"} ; -- 

Prefer = extTransVerb (vFinna "fredrag" "fredrog" "fredrag") [] ** {s3 = "framfr"} ; --- fredra
Put = extTransVerb (vFinna "stt" "satte" "satt") [] ** {s3 = "i"} ; 
Talk2 = extTransVerb (vTala "tal") ["med"] ** {s3 = "om"} ;


-- Verb med satskomplement
-- kan bara ta fullstndiga satser, inledda med att?
Say = extVerb Act (vLeka "sg") ;
Prove = extVerb Act (vTala "bevis") ;


Hope  = extVerb Pass(vTala "hopp") ;-- har ej deponens?
Believe = extTransVerb (vTala "lit") "p" ;
Know = extVerb Act (vTala "vet") ;

-- Verb som tar infinitivt verb, "ha" tar emellertid supinum
UseToVV = extVerb Act (vTala "bruk") ** {isAux = True} ;
RefuseVV    = extVerb Act (vTala "vgr") ** {isAux = variants{False;True}} ;
HaveVV    = extVerb Act (vHyra "har") ** {isAux = True} ; -- finns ju redan, mste kolla
SeemVV = extVerb Act (vTala "verk")  ** {isAux = True};
ShallVV = extVerb Act (vTala "skull")  ** {isAux = True};
ContinueVV = extVerb Act (vFinna "fortstt" "fortsatte" "fortsatt")  ** {isAux = variants{False;True}} ;
DeserveVV = extVerb Act (vTala "frtjn")  ** {isAux = variants{False;True}} ;
TryVV    = extVerb Act (vLeka "frsk") ** {isAux = variants{False;True}} ;

--Partikelverb
SwitchOn = mkDirectVerb (extVerbPart Act (vFinna "stt" "satte" "satt") "p") ;
SwitchOff = mkDirectVerb (extVerbPart Act (vLeka "stng") "av") ;
ArriveX = extVerbPart Act (vFinna "komm" "kom" "kommit") "fram" ;

-- Transitiva verb med obligatorisk pp
Talk = extTransVerb (vTala "prat") "med" ;
Trust = extTransVerb (vTala "lit") "p" ;

--Adverb
Always = advPre "alltid" ;
Well = advPost "bra" ;
Now = advPost "nu" ;
Difficult = advPost "svrt" ;
ToNight = advPost "ikvll" ;

-- Pronomen
John = mkProperName "Johan" Utr Masc ;
Mary = mkProperName "Maria" Utr NoMasc ;
Pelle = mkProperName "Pelle" Utr Masc ;
Liza = mkProperName "Lisa" Utr NoMasc ;
Phido = mkProperName "Fido" Utr NoMasc ;
Charlie = mkProperName "Kalle" Utr Masc ;
Anders = mkProperName "Anders" Utr Masc ;

-- verbVara = extVerb Act vara_1200 ;
-- verbHava = extVerb Act hava_1198 ;
-- verbFinnas = mkVerb "finnas" "finns" "finns" ;

} ;